
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

# define N 5 /* numero di utenti */
# define M 4 /* numero code di uscita */
# define costo_A 1/60
# define costo_B 1/45
# define costo_C 1/10
# define costo_D 1/10




 enum type { CLOSE,CALL};
 enum out { A,B,C,D};


typedef struct message {
             int type;
             char  source[7];
             char  destination[10];
             struct message * next;
} * elem,lista;






typedef struct _coda  {

        elem first,last;

        } coda;





typedef struct _tab {

             char source[7];
             int conteggio;
             int type;
             int out;
             time_t init_time;

}tab;



/*  solo per esempio pc */
/************************////////////////
void iniz(coda * qx);
void visualizza(tab * tx);     /*per visualizzare non e' necessario passare l'indirizzo*/
void enqueue( coda  * x,lista z);
void visual(elem lis);
void crea_tab(tab * tx);

/***********************************//////////








void dequeue(coda * ,elem *  );
void smista ( coda *,elem,tab *);
void aggiorna(tab * ,int);
void tariffa(tab *);



void main (){
	char c;
    tab tabella[N];
    int esci;
    coda q_in;
    coda q_out[M];

    int numq    ;    /****************************************/
    message aux,*ausil;      /****************************************/


    elem p;


     	for(int i=0;i<M;i++)
		iniz(&q_out[i]);

        iniz(&q_in);

   crea_tab(tabella);

	do
	{

		printf("\n MAIN MENU':\n"
        "\t\t1- VISUALIZZA TABELLA .\n"
		"\t\t2- INCODA .\n"
		"\t\t3- SMISTA \n"
        "\t\t4- VISUALIZZA CODE IN.\n"
        "\t\t5- VISUALIZZA CODE OUT.\n"
        "\t\t0- EXIT.");
		scanf("%d",&c);


	if (c>6 || c<0 )
	printf("ERROR NUMERO ERRATO");
	else {


	switch (c){
case 1 :

           	visualizza( tabella);
		   break;
case 2 :


           printf("inserisci type: ");
           scanf ("%d",&aux.type);



           printf("\n inserisci sorgente: ");
           scanf ("%s",&aux.source);

           printf("\n inserisci destinazione: ");
           scanf ("%s",&aux.destination);


           enqueue( &q_in,aux );


	    break;

case 3 :



    esci=0;
    while ( !esci){
    esci=1;
       dequeue(&q_in,&p);

        if(p !=NULL)
            {
                esci =0;

                  //k=ricerca(tabella,p->source);
                  smista(q_out,p,tabella);



            }
        }

		break;

case 4 :



	    ausil=q_in.first;

        if(ausil !=NULL)
          {
            printf("\nCoda IN : \n");
                visual(ausil);
          }


		break;

case 5 :

    for (int i=0;i<M;i++){

	    ausil=q_out[i].first;

        if(ausil !=NULL)
          {

           printf("\nCoda  : %c ", 0x341+i);
                visual(ausil);
          }
        }

		break;


default :
	printf	("END COMPUTATION\n");
	break;
	}
	}
	}
	 while (c !=0);
}







void 	enqueue(coda * qq,lista aux1){
	lista * ax;

	ax=(lista *)malloc(sizeof(lista));

    ax->type=aux1.type;
    strcpy(ax->source ,aux1.source);
    strcpy(ax->destination,aux1.destination);

    ax->next=NULL;

	if(qq->first == NULL)
	{

        qq->first=ax;
        qq->last=ax;

        	}
	else
	{
        qq->last->next=ax;
        qq->last=ax;
		}


    return ;
}





 void dequeue(coda * qq, elem  *px){



       *px=qq->first;
	   if (qq->first!=NULL){



         qq->first= qq->first->next;
         }
     else
            {

		    qq->last=NULL;
             }

	 return ;

 }




 void iniz(coda * qq){
  qq->first=NULL;
  qq->last=NULL;

  }






int  ricerca(tab *tabella,char * sx) {


                           int i=0;


                            while(   !(strcmp(tabella[i].source,sx)==0) && (i<M)){
                                i++;

                                 }

                            return i;
                           }








void crea_tab(tab * tx){
        printf("\n %d utenti \n",N);
         for (int j=0;j<N;j++){
           printf("\n inserisci utente %d : ",j+1);
           scanf ("%s",tx[j].source);
            //tx[j].destination="generico";
            tx[j].conteggio=0;
            tx[j].type=CLOSE;
            tx[j].init_time=0;
            tx[j].out=4;

            }
        }





void visual (elem ax){


  	   if (ax != NULL)
	   {

       printf("\tSorgente=%s \tDestinazione=%s \tType=%d\n",ax->source,ax->destination,ax->type);
       visual(ax->next);
	   }
}
void visualizza (tab * tabella){
           printf("\n");
  	   for (int j=0;j<N;j++){
           printf(" sorgente: %7s,",tabella[j].source);
           printf(" conteggio:%3d,",tabella[j].conteggio);
           printf(" type: %1d,",tabella[j].type);
           printf("\t data: %s",ctime(&(tabella[j].init_time)));

        }



 return;
}




void  smista(coda *q_out,elem px,tab *tabella){

    int k=ricerca(tabella,px->source);

     int stato=tabella[k].type;
     int out;
     char init2[3];







     if( (stato == CLOSE) && (px->type==CALL) )
        {
            init2[0]=px->source[0];
            init2[1]=px->source[1];
            //printf("SMISTA %s", init2);
            if( strcmp("72",init2)==0){  ////// numero iniziale
            printf("\n In coda: A ");
            enqueue(&q_out[A],*px);
            aggiorna(&tabella[k],A);
            }
            if( strcmp("31",init2)==0){
            enqueue(&q_out[B],*px);
            aggiorna(&tabella[k],B);
            printf("\n In coda: B ");

            }
            if( strcmp("42",init2)==0){
            enqueue(&q_out[C],*px);
            aggiorna(&tabella[k],C);
            printf("\n In coda: C ");

            }
            if( strcmp("00",init2)==0){
            enqueue(&q_out[D],*px);
            aggiorna(&tabella[k],D);
            printf("\n In coda: D ");

            }
        }


     else if( (stato == CALL) && (px->type==CLOSE) ){

      tariffa(&tabella[k]);


        }
       else
       {

       delete px;
       }

    return ;
}


void aggiorna(tab * tabella, int out){



   tabella->out=out;
   tabella->type=CALL;
   tabella->init_time=time(NULL);




}

void tariffa (tab *tabella){
    int out=tabella->out;
    int conteggio=tabella->conteggio;
    int diff;
    time_t actual;

    actual= time(NULL);
    diff=(int)difftime(actual,tabella->init_time);



    tabella->init_time=0;
    if (out == A) conteggio += 1+costo_A*diff;
    if (out == B) conteggio += 1+costo_B*diff;
    if (out == C) conteggio += 2+costo_C*diff;
    if (out == D) conteggio += 2+costo_D*diff;

    tabella->conteggio=conteggio;
    tabella->type=0;
    }
