#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
# define N 5 /* numero di porte in ingresso == ai destinatari */
#define COSTO_KM 70 // LIRE AL KM
#define LIMITE_V 100 // KM ORARI







typedef struct _record {

             int ingresso;
             char targa[7];
             time_t init_time;
             struct _record * next;

}record,*pRecord ;




typedef struct coda
{

        pRecord  first,last;

 }coda,*pCoda;





typedef struct _tab {



             int distanza;
             int num_caselli;
             pCoda caselli_ingr;

}tab;



/*  solo per esempio pc */
/************************////////////////
void iniz(coda * qx);
void visualizza(tab * tx);     /*per visualizzare non e' necessario passare l'indirizzo*/
void enqueue( coda  * x,record  );
void visual(pRecord lis);
void crea_tab(tab * tx);

/***********************************//////////








void dequeue(coda * ,pRecord *  );
void in_list(pRecord *, pRecord );
int tariffa(pRecord *,pRecord,tab *);
void ricerca(pRecord *,pRecord,pRecord *);
void multa();





void main (){
	char c;
    int att,i=0,trov=0;
    tab tabella[N];
    pRecord lista_cond=NULL;
    coda uscita;



    crea_tab(tabella);

    while( (i<N) && (!trov))
    {
    if(tabella[i].distanza==0)trov=1;
    else i++;
    }
    att=i;
    tabella[att].caselli_ingr=(pCoda)malloc(tabella[att].num_caselli*sizeof(coda));

    int esci;


    int numq    ;    /****************************************/
    record *ausil;      /****************************************/
    record aux;

    pRecord p;


     	for( i=0;i<tabella[att].num_caselli;i++)
		iniz(&tabella[att].caselli_ingr[i]);


        iniz(&uscita);


	do
	{

		printf("\n MAIN MENU':\n"
		"\t\t1- VISUALIZZA TABELLA .\n"
		"\t\t2- IN CASELLO GENERICO.\n"
		"\t\t3- SMISTA \n"
        "\t\t4- VISUALIZZA LISTA CONDIVISA.\n"
        "\t\t5- OUT CASELLO GENERICO.\n"
        "\t\t6- TARIFFA.\n"
        "\t\t0- EXIT.");
		scanf("%d",&c);


	if (c>6 || c<0 )
	printf("ERROR NUMERO ERRATO");
	else {


	switch (c){
case 1 :

           	visualizza( tabella);
		   break;
case 2 :

	       printf("inserisci numero coda da 0 a %d:", tabella[att].num_caselli-1);
	       scanf ("%d",&numq);

        if ( ( numq >-1 ) && (numq <N)){




           printf("inserire targa:");
           scanf ("%s",aux.targa);

           aux.ingresso=att;
           aux.init_time=time(NULL);
           enqueue( &tabella[att].caselli_ingr[numq],aux );
        }
        else
         printf(" numero errato");

	    break;

case 3 :

  /* POLLING */




	for (int i=0;i<tabella[att].num_caselli;i++)
    {
      esci=0;
      while ( !esci)
      {
       esci=1;
	   dequeue(&tabella[att].caselli_ingr[i],&p);
        if(p !=NULL)
            {
                esci =0;

                in_list(&lista_cond,p);

          //delete p;
            }
       }
    }

		break;


case 4 :

   // for (int i=0;i<tabella[att].num_caselli;i++){

	    ausil=lista_cond;//*/tabella[att].caselli_ingr[i].first;

        if(ausil !=NULL)
          {
            printf("\n Lista Cond :\n");

            visual(ausil);
          }
    //   }

		break;

case 5 :
           printf("inserire targa:");
           scanf ("%s",aux.targa);

           printf("inserire barriera di ingresso diversa dall'attuale (%d)",att);
           scanf("%d",&aux.ingresso);

           aux.init_time=time(NULL);
           enqueue( &uscita,aux );

	    break;

case 6 :

        esci=0;
        while(!esci)
        {
        esci=1;
        dequeue(&uscita,&p);
        if(p != NULL)
        {
        if(tariffa(&lista_cond,p,tabella))   multa();

        delete p;

        }

        }


		break;

default :
	printf	("END COMPUTATION\n");
	break;
	}
	}
	}
	 while (c !=0);
}







void 	enqueue(coda * qq,record aux1)
{
	pRecord ax=(pRecord )malloc(sizeof(record));
    ax->ingresso=aux1.ingresso;
    strcpy(ax->targa,aux1.targa);
    ax->init_time=time(NULL);
    ax->next=NULL;

	if(qq->first == NULL)
	{

        qq->first=ax;
        qq->last=ax;

        	}
	else
	{
        qq->last->next=ax;
        qq->last=ax;
		}


    return ;
}





 void dequeue(coda * qq, pRecord  *px)
 {

       *px=qq->first;
	   if (qq->first!=NULL)
       {
       qq->first= qq->first->next;
       }
       else
       {
       qq->last=NULL;
       }
    return ;
 }




 void iniz(coda * qq)
 {
  qq->first=NULL;
  qq->last=NULL;
 }







void crea_tab(tab * tx)
{
        int att,num;
        printf("\nTabella per la gestione di %d barriere di pedaggio\n",N);
        printf("\n Inserire numero barriera attuale  :\n");
        scanf ("%d",&att);
        for (int j=0;j<N;j++)
        {
         if(att==j)
          {
          printf("\n Inserire numero di caselli di ingresso:\n");
          scanf ("%d",&num);
          tx[j].num_caselli=num;
          tx[j].distanza=0;
          }
          else
          {
          printf("Distanza da barriera %d a barriera %d\n",att,j);
          scanf ("%d",&num);
          tx[j].distanza=num;
          }
        }

}



void visual (pRecord ax)
{

  	   if (ax != NULL)
	   {
       printf("\tTarga=%s \tIngresso =%d \tTempo ingresso=%s\n",ax->targa,ax->ingresso,ctime(&ax->init_time));
       visual(ax->next);
	   }
}

void visualizza (tab * tabella)
{
    int att,dist;
    printf("\n casello \t distanza dall'attuale barriera \n");
  	   for (int j=0;j<N;j++)
       {
            dist=tabella[j].distanza;
           printf("\t%d \t %d\n ",j,dist);
           if(dist==0)att=j;
       }

     printf("\n numero di caselli nell'attuale barriera  %d \n",tabella[att].num_caselli);

 return;
}



void in_list(pRecord * p, pRecord  ax)
{

     int k,trov=0;

     pRecord  prec=NULL;
     pRecord  aux=*p;
     ax->next=NULL;


 while((aux!=NULL)&&(!trov))

  {
     k=strcmp(ax->targa,aux->targa);

     if(k<0)
        {
         trov=1;
        }
     else
        {
        prec=aux;
        aux=aux->next;
        }
  }
    if (prec==NULL)
    {
     ax->next=aux;
     *p=ax;
    }
    else
    {
     prec->next=ax;
     ax->next=aux;
    }
}


int tariffa(pRecord * lista ,pRecord p, tab * tabella)
{
    pRecord aux;
    ricerca(lista,p,&aux);
    int conto,multa,ret=0;
    double diff;
    time_t t;

    if(aux) {
             t=time(NULL);
             conto=COSTO_KM*tabella[p->ingresso].distanza;


              printf("L'utente con targa %s proveniente"
                     "  da %d "
                     " paga : %d\n",aux->targa,aux->ingresso,conto);

    diff=difftime(t,aux->init_time);
    multa=tabella[p->ingresso].distanza/(diff/3600);
     printf("\nLa velocit dell'utente e':%d", multa);
    if(multa>LIMITE_V) ret =1;
    delete aux;
    }

    return ret;

}

void multa(){


printf("\nMultato per eccesso di velocit")  ;


}

void ricerca(pRecord *p,pRecord px, pRecord *out)
 {
   pRecord aux,prec=NULL;
   int trov=0;

   aux =*p;

    while((aux!=NULL)&& (!trov))
    {


      if(strcmp(px->targa,aux->targa)==0)
      {
      trov=1;
      }
      else
      {
      aux=aux->next;
      }
     }
     if (trov)
      {
        if(prec==NULL)
        {
        *p=(aux->next);
        }
        else
        {
        prec->next=aux->next;
        }

      }
      *out=aux;
}
