#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

# define N 10

typedef struct _message_in {

             char * dati;
             int destinazione;
             int selezione;
             struct _message_in * next;
}message_in ,* elem_in;



typedef struct _message_out {

             char * dati;
             int selezione;
             struct _message_out * next;
}message_out ,* elem_out;






typedef struct _coda_in  {

        elem_in first,last;

        }coda_in;

typedef struct _coda_out  {

        elem_out first,last;

        }coda_out;



typedef struct _lista_dopp

                {

                int selezione;
                char * dati;
                struct _lista_dopp *next;
                struct _lista_dopp *prec;

                }lista_dopp,*plista_dopp;

typedef struct _pila {

             int selezione;
             char * dati;
             struct _pila * next;

} pila,*ppila;










void iniz_out(coda_out * );
void dequeue(coda_in * ,elem_in *  );
void inoltra(coda_out * ,elem_in );
void in_pila(ppila*,elem_in  );
void in_lista(plista_dopp  *,elem_in  );






void main (){


    int esci;
    coda_in  qx_in[N];
    coda_out qx_out[N];


    elem_in p;


    ppila pil=NULL; // albero per il proc A
    plista_dopp lista_out=NULL; // lista dopp. conc. per il proc B





	for(int i=0;i<N;i++)
		iniz_out(&qx_out[i]);





  /* PROCESSI A B D  */

    esci=0;
    while ( !esci){
    esci=1;

	for (int i=0;i<N;i++){
	   dequeue(&qx_in[i],&p);

        if(p !=NULL)
            {
              esci =0;

              // processo D
              inoltra(&qx_out[p->destinazione],p);

              // processo A
              if( (i%2)==0 )in_pila(&pil,p);

              // processo B

              else in_lista(&lista_out,p);


              delete p;
            }
       }
    }


}






void 	enqueue(coda_in * qq,message_in aux1){
	 elem_in ax;
    ax=(elem_in)malloc(sizeof(message_in));


    ax->destinazione=aux1.destinazione;
    ax->selezione=aux1.selezione;
    ax->dati=aux1.dati;
    ax->next=NULL;

	if(qq->first == NULL)
	{
     qq->first=ax;
     qq->last=ax;
    }
	else
	{
       qq->last->next=ax;
       qq->last=ax;
	 }
    return ;
}








void 	inoltra(coda_out * qq,elem_in aux1){
    elem_out ax;
    ax=(elem_out)malloc(sizeof(message_out));

    ax->selezione=aux1->selezione;
    ax->dati=aux1->dati;
    ax->next=NULL;

	if(qq->first == NULL)
	{
        qq->first=ax;
        qq->last=ax;
    }
	else
	{
        qq->last->next=ax;
        qq->last=ax;
	}
    return ;
}


void dequeue(coda_in * qq, elem_in  *px){
       *px=qq->first;


	   if (qq->first!=NULL)
        {
           qq->first= qq->first->next;
        }
       else
         {
         qq->last=NULL;
         }
    return ;
}



void iniz_out(coda_out * qq){
  qq->first=NULL;
  qq->last=NULL;

  }





void in_pila(ppila *pil, elem_in p){

    ppila aux;


	aux	=(ppila)malloc(sizeof(pila));
    aux->selezione=p->selezione;
    aux->dati=p->dati;
    aux->next=*pil;
    *pil=aux;

      return;
}



void in_lista(plista_dopp  * p,elem_in p_in  ){

 	plista_dopp ax,aux;
    int num;
    int trov=0;
    int fine=0;

	ax	=(plista_dopp)malloc(sizeof(lista_dopp));

	ax->selezione=num=p_in->selezione;
    ax->dati=p_in->dati;


    aux=*p;

    if(aux == NULL)
	{
		ax->next=aux;
        ax->prec=aux;
        *p=ax;
    }
    else
    {
       while ((!fine) && (!trov))
       {
            if (num < aux->selezione)
            {
            trov=1;
            }
            else
            {
              if(aux->next)( aux=aux->next);
              else fine=1;
            }
       }

       if(trov)
       {
            if(aux->prec)  //// al centro
            {
            ax->next=aux;
            ax->prec=aux->prec;
            aux->prec->next=ax;
            aux->prec=ax;

            }
            else          ////// in testa
            {
            ax->next=aux;
            ax->prec=NULL;
            aux->prec=ax;
            *p=ax;

            }

       }               /////// alla fine
       else
       {
       ax->next=NULL;
       aux->next=ax;
       ax->prec=aux;


       }


    }



}



