#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
# define N 5 /* numero di barriere totali*/

#define COSTO_KM 70 // LIRE AL KM
#define LIMITE_V 100 // KM ORARI
#define INGRESSO 1 // Modific a zero funziona all'uscita di una generica barriera






typedef struct _record {

             int ingresso;
             char targa[7];
             time_t init_time;
             struct _record * next;

}record,*pRecord ;




typedef struct coda
{

        pRecord  first,last;

 }coda,*pCoda;





typedef struct _tab {



             int distanza;
             int num_caselli;
             pCoda caselli_ingr;

}tab;






void iniz(coda * qx);
void dequeue(coda * ,pRecord *  );
void in_list(pRecord *, pRecord );
int tariffa(pRecord *,pRecord,tab *);
void ricerca(pRecord *,pRecord,pRecord *);
void multa();
void stampa(int);





void main ()
{

    int att,i=0,trov=0;
    tab tabella[N];
    pRecord lista_cond=NULL;
    coda uscita; // coda su cui arrivano richieste di uscita dall'autostrada





    while( (i<N) && (!trov))
    {
    if(tabella[i].distanza==0)trov=1;
    else i++;
    }
    att=i;
    tabella[att].caselli_ingr=(pCoda)malloc(tabella[att].num_caselli*sizeof(coda));

    int esci;


    

    pRecord p;


     	for( i=0;i<tabella[att].num_caselli;i++)
		iniz(&tabella[att].caselli_ingr[i]);








if(INGRESSO)
    {

/// per svuotare singolo buffer alla volta
	for (int i=0;i<tabella[att].num_caselli;i++)
    {
      esci=0;
      while ( !esci)
      {
       esci=1;
	   dequeue(&tabella[att].caselli_ingr[i],&p);
        if(p !=NULL)
            {
                esci =0;

                in_list(&lista_cond,p);


            }
       }
    }

  }
else
    {




        esci=0;
        while(!esci)
        {
        esci=1;
        dequeue(&uscita,&p);
        if(p != NULL)
            {
            if(tariffa(&lista_cond,p,tabella))   multa();

            delete p;

            }

        }
    }
}    



 void dequeue(coda * qq, pRecord  *px)
 {

       *px=qq->first;
	   if (qq->first!=NULL)
       {
       qq->first= qq->first->next;
       }
       else
       {
       qq->last=NULL;
       }
    return ;
 }




 void iniz(coda * qq)
 {
  qq->first=NULL;
  qq->last=NULL;
 }





void in_list(pRecord * p, pRecord  ax)
{

     int k,trov=0;

     pRecord  prec=NULL;
     pRecord  aux=*p;
     ax->next=NULL;


 while((aux!=NULL)&&(!trov))

  {
     k=strcmp(ax->targa,aux->targa);

     if(k<0)
        {
         trov=1;
        }
     else
        {
        prec=aux;
        aux=aux->next;
        }
  }
    if (prec==NULL)
    {
     ax->next=aux;
     *p=ax;
    }
    else
    {
     prec->next=ax;
     ax->next=aux;
    }
}


int tariffa(pRecord * lista ,pRecord p, tab * tabella)
{
    pRecord aux;
    ricerca(lista,p,&aux);
    int conto,multa,ret=0;
    double diff;
    time_t t;

    if(aux) {
             t=time(NULL);
             conto=COSTO_KM*tabella[p->ingresso].distanza;

             stampa(conto);

    diff=difftime(t,aux->init_time);
    multa=tabella[p->ingresso].distanza/(diff/3600);

    if(multa>LIMITE_V) ret =1;
    delete aux;
    }

    return ret;

}

void multa(){





}

void stampa( int costo){

}


void ricerca(pRecord *p,pRecord px, pRecord *out)
 {
   pRecord aux,prec=NULL;
   int trov=0;

   aux =*p;

    while((aux!=NULL)&& (!trov))
    {


      if(strcmp(px->targa,aux->targa)==0)
      {
      trov=1;
      }
      else
      {
      aux=aux->next;
      }
     }
     if (trov)
      {
        if(prec==NULL)
        {
        *p=(aux->next);
        }
        else
        {
        prec->next=aux->next;
        }

      }
      *out=aux;
}
