#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

# define N 10

struct message {

             char source[8];
             char destination[8];
             char info[255];

	struct message * next;
};



typedef struct message lista;
typedef lista * elem;



struct base_cod  {

        elem first,last;

        };

typedef struct base_cod   coda ;



 struct albero {

             char utente[8];
             int porta;

	struct albero * fs;
    struct albero * fd;
};


typedef struct albero abr ;







void iniz(coda * qx);
void visualizza(abr * lis);     /*per visualizzare non e' necessario passare l'indirizzo*/
void enqueue( coda  * x,lista z);
void visual(elem lis);




void dequeue(coda * ,elem *  );
void aggiorna(abr **,elem  ,int );
int  ricerca(abr *,elem  );
void spedisci(coda * , elem * ps);




void main (){
	char c;

    int esci,k;
    coda qx[N][2];

    int numq    ;    /****************************************/
    message aux;      /****************************************/


    elem p,aus=NULL;
    abr * al=NULL;




    for(int j=0;j<N;j++)
    iniz(&qx[j][1]);

	for(int i=0;i<N;i++)
		iniz(&qx[i][0]);



	do
	{

		printf("\n MAIN MENU':\n"
		"\t\t1- VISUALIZZA ALBERO.\n"
		"\t\t2- INCODA GENERICA.\n"
		"\t\t3- BRIDGE \n"
        "\t\t4- VISUALIZZA CODE IN.\n"
        "\t\t5- VISUALIZZA CODE OUT.\n"
		"\t\t0- EXIT.");
		scanf("%d",&c);


	if (c>5 || c<0 )
	printf("ERROR NUMERO ERRATO");
	else {


	switch (c){
case 1 :
	    if(al != NULL)
		{
           	visualizza( al);
		}
	else
		   printf("ERRORE ALBERO VUOTO\n");
		   break;
case 2 :

	       printf("inserisci numero coda da 0 a %d:", N-1);
	       scanf ("%d",&numq);

        if ( ( numq >-1 ) && (numq <N)){




           printf("inserisci source:");
           scanf ("%s",aux.source);

           printf("inserisci destinazione:");
           scanf ("%s",aux.destination);

           printf("inserisci informazione:");
           scanf ("%s",aux.info);







           enqueue( &qx[numq][0],aux );
        }
        else
         printf(" numero errato");

	    break;

case 3 :

  /* POLLING */

    esci=0;
    while ( !esci){
    esci=1;
	for (int i=0;i<N;i++){
	   dequeue(&qx[i][0],&p);

        if(p !=NULL)
            {
                esci =0;
                aggiorna(&al,p,i+1);
                  k=ricerca(al,p);
                  printf("\n %d",k-1);
                if(k)

                    spedisci(&qx[k-1][1],&p);

                else     {
                        for(int j=0;j<N;j++){
                         if(j!=i)
                            spedisci(&qx[j][1],&p);

                             }

                        }

            }
       }
    }

		break;

case 4 :

    for (int i=0;i<N;i++){

	    aus=qx[i][0].first;

        if(aus !=NULL)
          {
            printf("\nCoda Num : %d",i);
                visual(aus);
          }
        }

		break;

case 5 :

   	for (int i=0;i<N;i++){
	   aus=qx[i][1].first;

        if(aus !=NULL){
           printf("\nCoda Num : %d",i);


                visual(aus);
       }

   }
		break;

default :
	printf	("END COMPUTATION\n");
	break;
	}
	}
	}
	 while (c !=0);
}


void visualizza (abr *ax){

  	   if (ax != NULL)
	   {
       visualizza(ax->fs);
       printf("\tUtente=%s \tPorta associata =%d \n",ax->utente,ax->porta-1);
       visualizza(ax->fd);
	   }


 return;
}

void 	enqueue(coda * qq,lista aux1){
	lista * ax;



	ax=(lista *)malloc(sizeof(lista));


    strcpy(ax->info,aux1.info);
    strcpy(ax->source,aux1.source);
    strcpy(ax->destination,aux1.destination);







    ax->next=NULL;

	if(qq->first == NULL)
	{

        qq->first=ax;
        qq->last=ax;

        	}
	else
	{
        qq->last->next=ax;
        qq->last=ax;
		}


    return ;
}



 void dequeue(coda * qq, elem  *px){



       *px=qq->first;
	   if (qq->first!=NULL){



         qq->first= qq->first->next;
         }
     else
            {

		    qq->last=NULL;
             }

	 return ;

 }


 void iniz(coda * qq){
  qq->first=NULL;
  qq->last=NULL;

  }




void  spedisci(coda * qq,elem * ax){



    (*ax)->next=NULL;

	if(qq->first == NULL)
	{

        qq->first=(*ax);
        qq->last=(*ax);

        	}
	else
	{
        qq->last->next=(*ax);
        qq->last=(*ax);
		}


    return ;
}

void aggiorna(albero **alb, elem px,int mc)
             					{

                                   int k=0;


                           	if((*alb)==NULL)
                              {
                                (*alb)= (albero*)malloc (sizeof(albero));
                               (*alb)->porta=mc;
                               strcpy((*alb)->utente,px->source);
                               (*alb)->fs=NULL;
                               (*alb)->fd=NULL;
                               }
                              else
                              {
                              k=strcmp(px->source,(*alb)->utente);
                                if(k<0)
                               {aggiorna(&((*alb)->fs),px,mc);}
                               else if(k>0)
                               {aggiorna(&((*alb)->fd),px,mc);}

                                   }

                               return;
                             }


int  ricerca(albero * alb, elem px) {

                           int k=0;
                           int out;


                           	if(alb==NULL)
                              {
                               out= 0;
                               }
                             else
                             {
                              k=strcmp(px->destination,alb->utente);

                                if(k<0)
                               {out=ricerca(alb->fs,px);}

                               else if(k>0)

                               {out=ricerca(alb->fd,px);}

                                 else if(k==0)
                               {
                               out= alb->porta;


                                   }
                              }
                            return out;
                           }



void visual (elem ax){

  	   if (ax != NULL)
	   {

       printf("\tSource=%s \tDestination=%s \tInfo=%s\n",ax->source,ax->destination,ax->info);
       visual(ax->next);
	   }
}
